//+------------------------------------------------------------------+
//|                                                  Cyber Itrend.mq4 |
//| Original Code for Tradestation from the book of John F. Ehlers'  |
//| 'Cybernetic Analysis for Stocks and Futures'                     |
//| (Original code at bottom)                                        |
//| Linuxser 2007 for TSD    http://www.forex-tsd.com/               |
//+------------------------------------------------------------------+
#property copyright "Under The GNU General Public License"
#property link      "www.gnu.org"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#property  indicator_level1  0
#property  indicator_levelcolor  Silver
#property  indicator_levelstyle 2

//---- input parameters
extern int Price=4;
extern double alpha=0.07;

double NumOfBars=0;
double PeriodsP=8;
//---- buffers
double Smooth[];
double Itrend[];
double Trigger[];




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(4);

   SetIndexBuffer(0,Itrend);   
   SetIndexBuffer(1,Trigger);
   
//---- indicator lines
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, Itrend);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, Trigger);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2, Smooth);
   
   SetIndexLabel (0, "Cyber Itrend");
   SetIndexLabel (1, "Trigger of Cyber Itrend");
   
   IndicatorShortName("Itrend");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();  
   double Per1=PeriodsP;
   double Per2=PeriodsP;

//---- TODO: add your code here
   if(NumOfBars==0)NumOfBars=Bars;
   
   for(int i=NumOfBars-MathMax(PeriodsP,Per1)-1;i>=0;i--)
   
   {      
      
      if (NumOfBars < 7)
      {
      
      Smooth[i]= (iMA(NULL,0,1,0,0,Price,i) + (2*iMA(NULL,0,1,0,0,Price,i+1)) + (2*iMA(NULL,0,1,0,0,Price,i+2)))/4;
      
      }
      
      Smooth[i]= (iMA(NULL,0,1,0,0,Price,i) + (2*iMA(NULL,0,1,0,0,Price,i+1)) + (2*iMA(NULL,0,1,0,0,Price,i+2)) + iMA(NULL,0,1,0,0,Price,i+3))/6;    
            
      Itrend[i]= (alpha - alpha*alpha/4) * Smooth[i]+ 0.5*alpha*alpha*Smooth[i+1] - (alpha-0.75*alpha*alpha)*Smooth[i+2] + 2*(1 - alpha)*Itrend[i+1] - (1 - alpha)*(1 - alpha)*Itrend[i+2];
          
      Trigger[i]= Itrend[i+1];
   }         
     
//----
   return(0);
  }
  
/*
Price((H+L)/2),
alpha(.07);
Vars:
Smooth(0),
Itrend(0);
Smooth = (Price + 2*Price[1] + 2*Price[2] + Price[3])/6;
Itrend = (1 - .5*alpha)*(1 - .5*alpha)*(Smooth-2*Smooth[1] + Smooth[2]) + 2*(1 - alpha)*Itrend[1] - (1 - alpha)*(1 - alpha)*Itrend[2];
If currentbar < 7 
	then Itrend = (Price - 2*Price[1]+ Price[2]) / 4;
Plot1(Itrend, "Itrend");
Plot2(Itrend[1], "Trigger");
*/  